package org.hashtree.jbrainhoney.cryptography;

/** An implementation of a MD2 based Digest. */
public final class Md2Digest extends MessageDigest {
	private static final long serialVersionUID = 4934776079430796695L;

	private Md2Digest(final Builder builder) {
		super(builder);
	}

	/** A builder of immutable Md2Digest instances. */
	public final static class Builder extends MessageDigest.Builder {
		public Builder(final byte[] bytes) {
			super(Algorithm.MD2, bytes);
		}

		public Builder(final String bytes) {
			super(Algorithm.MD2, bytes);
		}

		@SuppressWarnings("synthetic-access")
		@Override
		public Md2Digest build() {
			return new Md2Digest(this);
		}
	}
}