package org.hashtree.jbrainhoney.cryptography;

/** An implementation of a MD5 based Digest. */
public final class Md5Digest extends MessageDigest {
	private static final long serialVersionUID = 7356412090876385L;

	private Md5Digest(final Builder builder) {
		super(builder);
	}

	/** A builder of immutable Md5Digest instances. */
	public final static class Builder extends MessageDigest.Builder {
		public Builder(final byte[] bytes) {
			super(Algorithm.MD5, bytes);
		}

		public Builder(final String bytes) {
			super(Algorithm.MD5, bytes);
		}

		@SuppressWarnings("synthetic-access")
		@Override
		public Md5Digest build() {
			return new Md5Digest(this);
		}
	}
}