package org.hashtree.jbrainhoney.cryptography;

/** An implementation of a SHA-1 based Digest. */
public final class Sha1Digest extends MessageDigest {
	private static final long serialVersionUID = 478859312348658921L;

	private Sha1Digest(final Builder builder) {
		super(builder);
	}

	/** A builder of immutable Sha1Digest instances. */
	public final static class Builder extends MessageDigest.Builder {
		public Builder(final byte[] bytes) {
			super(Algorithm.SHA1, bytes);
		}

		public Builder(final String bytes) {
			super(Algorithm.SHA1, bytes);
		}

		@SuppressWarnings("synthetic-access")
		@Override
		public Sha1Digest build() {
			return new Sha1Digest(this);
		}
	}
}