package org.hashtree.jbrainhoney.cryptography;

/** An implementation of a SHA-384 based Digest. */
public final class Sha384Digest extends MessageDigest {
	private static final long serialVersionUID = 395769275927664L;

	private Sha384Digest(final Builder builder) {
		super(builder);
	}

	/** A builder of immutable Sha384Digest instances. */
	public final static class Builder extends MessageDigest.Builder {
		public Builder(final byte[] bytes) {
			super(Algorithm.SHA384, bytes);
		}

		public Builder(final String bytes) {
			super(Algorithm.SHA384, bytes);
		}

		@SuppressWarnings("synthetic-access")
		@Override
		public Sha384Digest build() {
			return new Sha384Digest(this);
		}
	}
}