package org.hashtree.jbrainhoney.cryptography;

/** An implementation of a SHA-512 based Digest. */
public final class Sha512Digest extends MessageDigest {
	private static final long serialVersionUID = -45769366001925639L;

	private Sha512Digest(final Builder builder) {
		super(builder);
	}

	/** A builder of immutable Sha512Digest instances. */
	public final static class Builder extends MessageDigest.Builder {
		public Builder(final byte[] bytes) {
			super(Algorithm.SHA512, bytes);
		}

		public Builder(final String bytes) {
			super(Algorithm.SHA512, bytes);
		}

		@SuppressWarnings("synthetic-access")
		@Override
		public Sha512Digest build() {
			return new Sha512Digest(this);
		}
	}
}