package org.hashtree.jbrainhoney.dlap.command;

import java.util.List;
import org.hashtree.jbrainhoney.dlap.element.*;

/** A class which consists exclusively of static methods that operate on or return commands and their builders. */
public final class Commands {
	private Commands() {

	}

	public static <T extends Object> AddGroupMembersCommand.Builder
		newAddGroupMembersCommandBuilder(final String groupId, final List<T> enrollmentIds) {

		return new AddGroupMembersCommand.Builder(groupId, enrollmentIds);
	}

	public static <T extends Object> AddGroupMembersCommand.Builder
		newAddGroupMembersCommandBuilder(final Integer groupId, final List<T> enrollmentIds) {

		return new AddGroupMembersCommand.Builder(groupId, enrollmentIds);
	}

	public static AddGroupMembersCommand.Builder
		newAddGroupMembersCommandBuilder(final String groupId, final String enrollmentId) {

		return new AddGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static AddGroupMembersCommand.Builder
		newAddGroupMembersCommandBuilder(final String groupId, final Integer enrollmentId) {

		return new AddGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static AddGroupMembersCommand.Builder
		newAddGroupMembersCommandBuilder(final Integer groupId, final String enrollmentId) {

		return new AddGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static AddGroupMembersCommand.Builder
		newAddGroupMembersCommandBuilder(final Integer groupId, final Integer enrollmentId) {

		return new AddGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static CopyCoursesCommand.Builder newCopyCoursesCommandBuilder(final List<Course> courses) {
		return new CopyCoursesCommand.Builder(courses);
	}

	public static CopyCoursesCommand.Builder newCopyCoursesCommandBuilder(final Course course) {
		return new CopyCoursesCommand.Builder(course);
	}

	public static CreateCoursesCommand.Builder newCreateCoursesCommandBuilder(final List<Course> courses) {
		return new CreateCoursesCommand.Builder(courses);
	}

	public static CreateCoursesCommand.Builder newCreateCoursesCommandBuilder(final Course course) {
		return new CreateCoursesCommand.Builder(course);
	}

	public static CreateDomainsCommand.Builder
		newCreateDomainsCommandBuilder(final String parentId, final List<Domain> domains) {

		return new CreateDomainsCommand.Builder(parentId, domains);
	}

	public static CreateDomainsCommand.Builder
		newCreateDomainsCommandBuilder(final Integer parentId, final List<Domain> domains) {

		return new CreateDomainsCommand.Builder(parentId, domains);
	}

	public static CreateDomainsCommand.Builder
		newCreateDomainsCommandBuilder(final String parentId, final Domain domain) {

		return new CreateDomainsCommand.Builder(parentId, domain);
	}

	public static CreateDomainsCommand.Builder
		newCreateDomainsCommandBuilder(final Integer parentId, final Domain domain) {

		return new CreateDomainsCommand.Builder(parentId, domain);
	}

	public static CreateEnrollmentsCommand.Builder
		newCreateEnrollmentsCommandBuilder(final List<Enrollment> enrollments) {

		return new CreateEnrollmentsCommand.Builder(enrollments);
	}

	public static CreateEnrollmentsCommand.Builder
		newCreateEnrollmentsCommandBuilder(final Enrollment enrollment) {

		return new CreateEnrollmentsCommand.Builder(enrollment);
	}

	public static CreateGroupsCommand.Builder
		newCreateGroupsCommandBuilder(final List<Group> groups) {

		return new CreateGroupsCommand.Builder(groups);
	}

	public static CreateGroupsCommand.Builder
		newCreateGroupsCommandBuilder(final Group group) {

		return new CreateGroupsCommand.Builder(group);
	}

	public static CreateSectionsCommand.Builder
		newCreateSectionsCommandBuilder(final List<Section> sections) {

		return new CreateSectionsCommand.Builder(sections);
	}

	public static CreateSectionsCommand.Builder newCreateSectionsCommandBuilder(final Section section) {
		return new CreateSectionsCommand.Builder(section);
	}

	public static CreateUsersCommand.Builder newCreateUsersCommandBuilder(final List<User> users) {
		return new CreateUsersCommand.Builder(users);
	}

	public static CreateUsersCommand.Builder newCreateUsersCommandBuilder(final User user) {
		return new CreateUsersCommand.Builder(user);
	}

	public static DeleteCoursesCommand.Builder newDeleteCoursesCommandBuilder(final List<Course> courses) {
		return new DeleteCoursesCommand.Builder(courses);
	}

	public static DeleteCoursesCommand.Builder newDeleteCoursesCommandBuilder(final Course course) {
		return new DeleteCoursesCommand.Builder(course);
	}

	public static DeleteEnrollmentsCommand.Builder
		newDeleteEnrollmentsCommandBuilder(final List<Enrollment> enrollments) {

		return new DeleteEnrollmentsCommand.Builder(enrollments);
	}

	public static DeleteEnrollmentsCommand.Builder newDeleteEnrollmentsCommandBuilder(final Enrollment enrollment) {
		return new DeleteEnrollmentsCommand.Builder(enrollment);
	}

	public static DeleteGroupsCommand.Builder newDeleteGroupsCommandBuilder(final List<Group> groups) {
		return new DeleteGroupsCommand.Builder(groups);
	}

	public static DeleteGroupsCommand.Builder newDeleteGroupsCommandBuilder(final Group group) {
		return new DeleteGroupsCommand.Builder(group);
	}

	public static DeleteSectionsCommand.Builder newDeleteSectionsCommandBuilder(final List<Section> sections) {
		return new DeleteSectionsCommand.Builder(sections);
	}

	public static DeleteSectionsCommand.Builder newDeleteSectionsCommandBuilder(final Section section) {
		return new DeleteSectionsCommand.Builder(section);
	}

	public static DeleteUsersCommand.Builder newDeleteUsersCommandBuilder(final List<User> users) {
		return new DeleteUsersCommand.Builder(users);
	}

	public static DeleteUsersCommand.Builder newDeleteUsersCommandBuilder(final User user) {
		return new DeleteUsersCommand.Builder(user);
	}

	public static EchoCommand.Builder newEchoCommandBuilder(final String echo) {
		return new EchoCommand.Builder(echo);
	}

	public static GetCookieCommand.Builder newGetCookieCommandBuilder() {
		return new GetCookieCommand.Builder();
	}

	public static GetCourseCommand.Builder newGetCourseCommandBuilder(final String courseId) {
		return new GetCourseCommand.Builder(courseId);
	}

	public static GetCourseCommand.Builder newGetCourseCommandBuilder(final Integer courseId) {
		return new GetCourseCommand.Builder(courseId);
	}

	public static GetCourseListCommand.Builder newGetCourseListCommandBuilder() {
		return new GetCourseListCommand.Builder();
	}

	public static GetDomainCommand.Builder newGetDomainCommandBuilder(final String domainId) {
		return new GetDomainCommand.Builder(domainId);
	}

	public static GetDomainCommand.Builder newGetDomainCommandBuilder(final Integer domainId) {
		return new GetDomainCommand.Builder(domainId);
	}

	public static GetDomainListCommand.Builder newGetDomainListCommandBuilder() {
		return new GetDomainListCommand.Builder();
	}

	public static GetDomainParentListCommand.Builder newGetDomainParentListCommandBuilder(final String domainId) {
		return new GetDomainParentListCommand.Builder(domainId);
	}

	public static GetDomainParentListCommand.Builder newGetDomainParentListCommandBuilder(final Integer domainId) {
		return new GetDomainParentListCommand.Builder(domainId);
	}

	public static GetEnrollmentCommand.Builder newGetEnrollmentCommandBuilder(final String enrollmentId) {
		return new GetEnrollmentCommand.Builder(enrollmentId);
	}

	public static GetEnrollmentCommand.Builder newGetEnrollmentCommandBuilder(final Integer enrollmentId) {
		return new GetEnrollmentCommand.Builder(enrollmentId);
	}

	public static GetEnrollmentGroupListCommand.Builder
		newGetEnrollmentGroupListCommandBuilder(final String enrollmentId) {

		return new GetEnrollmentGroupListCommand.Builder(enrollmentId);
	}

	public static GetEnrollmentGroupListCommand.Builder
		newGetEnrollmentGroupListCommandBuilder(final Integer enrollmentId) {

		return new GetEnrollmentGroupListCommand.Builder(enrollmentId);
	}

	public static GetEntityEnrollmentListCommand.Builder
		newGetEntityEnrollmentListCommandBuilder(final String entityId) {

		return new GetEntityEnrollmentListCommand.Builder(entityId);
	}

	public static GetEntityEnrollmentListCommand.Builder
		newGetEntityEnrollmentListCommandBuilder(final Integer entityId) {

		return new GetEntityEnrollmentListCommand.Builder(entityId);
	}

	public static GetEntityTypeCommand.Builder newGetEntityTypeCommandBuilder(final String entityId) {
		return new GetEntityTypeCommand.Builder(entityId);
	}

	public static GetEntityTypeCommand.Builder newGetEntityTypeCommandBuilder(final Integer entityId) {
		return new GetEntityTypeCommand.Builder(entityId);
	}

	public static GetGroupCommand.Builder newGetGroupCommandBuilder(final String groupId) {
		return new GetGroupCommand.Builder(groupId);
	}

	public static GetGroupCommand.Builder newGetGroupCommandBuilder(final Integer groupId) {
		return new GetGroupCommand.Builder(groupId);
	}

	public static GetGroupEnrollmentListCommand.Builder newGetGroupEnrollmentListCommandBuilder(final String groupId) {
		return new GetGroupEnrollmentListCommand.Builder(groupId);
	}

	public static GetGroupEnrollmentListCommand.Builder newGetGroupEnrollmentListCommandBuilder(final Integer groupId) {
		return new GetGroupEnrollmentListCommand.Builder(groupId);
	}

	public static GetGroupListCommand.Builder newGetGroupListCommandBuilder(final String ownerId) {
		return new GetGroupListCommand.Builder(ownerId);
	}

	public static GetGroupListCommand.Builder newGetGroupListCommandBuilder(final Integer ownerId) {
		return new GetGroupListCommand.Builder(ownerId);
	}

	public static GetRightCommand.Builder newGetRightCommandBuilder(final String actorId, final String entityId) {
		return new GetRightCommand.Builder(actorId, entityId);
	}

	public static GetRightCommand.Builder newGetRightCommandBuilder(final Integer actorId, final String entityId) {
		return new GetRightCommand.Builder(actorId, entityId);
	}

	public static GetRightCommand.Builder newGetRightCommandBuilder(final String actorId, final Integer entityId) {
		return new GetRightCommand.Builder(actorId, entityId);
	}

	public static GetRightCommand.Builder newGetRightCommandBuilder(final Integer actorId, final Integer entityId) {
		return new GetRightCommand.Builder(actorId, entityId);
	}

	public static GetSectionCommand.Builder newGetSectionCommandBuilder(final String sectionId) {
		return new GetSectionCommand.Builder(sectionId);
	}

	public static GetSectionCommand.Builder newGetSectionCommandBuilder(final Integer sectionId) {
		return new GetSectionCommand.Builder(sectionId);
	}

	public static GetSectionListCommand.Builder newGetSectionListCommandBuilder() {
		return new GetSectionListCommand.Builder();
	}

	public static GetUserCommand.Builder newGetUserCommandBuilder(final String userId) {
		return new GetUserCommand.Builder(userId);
	}

	public static GetUserCommand.Builder newGetUserCommandBuilder(final Integer userId) {
		return new GetUserCommand.Builder(userId);
	}

	public static GetUserEnrollmentListCommand.Builder newGetUserEnrollmentListCommandBuilder(final String userId) {
		return new GetUserEnrollmentListCommand.Builder(userId);
	}

	public static GetUserEnrollmentListCommand.Builder newGetUserEnrollmentListCommandBuilder(final Integer userId) {
		return new GetUserEnrollmentListCommand.Builder(userId);
	}

	public static GetUserListCommand.Builder newGetUserListCommandBuilder() {
		return new GetUserListCommand.Builder();
	}

	public static LinkDomainsCommand.Builder
		newLinkDomainsCommandBuilder(final String parentId, final List<Domain> domains) {

		return new LinkDomainsCommand.Builder(parentId, domains);
	}

	public static LinkDomainsCommand.Builder
		newLinkDomainsCommandBuilder(final Integer parentId, final List<Domain> domains) {

		return new LinkDomainsCommand.Builder(parentId, domains);
	}

	public static LinkDomainsCommand.Builder newLinkDomainsCommandBuilder(final String parentId, final Domain domain) {
		return new LinkDomainsCommand.Builder(parentId, domain);
	}

	public static LinkDomainsCommand.Builder newLinkDomainsCommandBuilder(final Integer parentId, final Domain domain) {
		return new LinkDomainsCommand.Builder(parentId, domain);
	}

	public static ListRestorableCoursesCommand.Builder newListRestorableCoursesCommandBuilder(final String domainId) {
		return new ListRestorableCoursesCommand.Builder(domainId);
	}

	public static ListRestorableCoursesCommand.Builder newListRestorableCoursesCommandBuilder(final Integer domainId) {
		return new ListRestorableCoursesCommand.Builder(domainId);
	}

	public static ListRestorableDomainsCommand.Builder newListRestorableDomainsCommandBuilder(final String parentId) {
		return new ListRestorableDomainsCommand.Builder(parentId);
	}

	public static ListRestorableDomainsCommand.Builder newListRestorableDomainsCommandBuilder(final Integer parentId) {
		return new ListRestorableDomainsCommand.Builder(parentId);
	}

	public static ListRestorableEnrollmentsCommand.Builder newListRestorableEnrollmentsCommandBuilder() {
		return new ListRestorableEnrollmentsCommand.Builder();
	}

	public static ListRestorableSectionsCommand.Builder newListRestorableSectionsCommandBuilder() {
		return new ListRestorableSectionsCommand.Builder();
	}

	public static ListRestorableUsersCommand.Builder newListRestorableUsersCommandBuilder(final String domainId) {
		return new ListRestorableUsersCommand.Builder(domainId);
	}

	public static ListRestorableUsersCommand.Builder newListRestorableUsersCommandBuilder(final Integer domainId) {
		return new ListRestorableUsersCommand.Builder(domainId);
	}

	public static LoginCommand.Builder newLoginCommandBuilder(final String username, final String password) {
		return new LoginCommand.Builder(username, password);
	}

	public static LogoutCommand.Builder newLogoutCommandBuilder() {
		return new LogoutCommand.Builder();
	}

	public static ProxyCommand.Builder newProxyCommandBuilder(final String userId) {
		return new ProxyCommand.Builder(userId);
	}

	public static ProxyCommand.Builder newProxyCommandBuilder(final Integer userId) {
		return new ProxyCommand.Builder(userId);
	}

	public static <T extends Object> RemoveGroupMembersCommand.Builder
		newRemoveGroupMembersCommandBuilder(final String groupId, final List<T> enrollmentIds) {

		return new RemoveGroupMembersCommand.Builder(groupId, enrollmentIds);
	}

	public static <T extends Object> RemoveGroupMembersCommand.Builder
		newRemoveGroupMembersCommandBuilder(final Integer groupId, final List<T> enrollmentIds) {

		return new RemoveGroupMembersCommand.Builder(groupId, enrollmentIds);
	}

	public static RemoveGroupMembersCommand.Builder
		newRemoveGroupMembersCommandBuilder(final String groupId, final String enrollmentId) {

		return new RemoveGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static RemoveGroupMembersCommand.Builder
		newRemoveGroupMembersCommandBuilder(final String groupId, final Integer enrollmentId) {

		return new RemoveGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static RemoveGroupMembersCommand.Builder
		newRemoveGroupMembersCommandBuilder(final Integer groupId, final String enrollmentId) {

		return new RemoveGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static RemoveGroupMembersCommand.Builder
		newRemoveGroupMembersCommandBuilder(final Integer groupId, final Integer enrollmentId) {

		return new RemoveGroupMembersCommand.Builder(groupId, enrollmentId);
	}

	public static ResetPasswordCommand.Builder newResetPasswordCommandBuilder(final String username) {
		return new ResetPasswordCommand.Builder(username);
	}

	public static RestoreCoursesCommand.Builder newRestoreCoursesCommandBuilder(final List<Course> courses) {
		return new RestoreCoursesCommand.Builder(courses);
	}

	public static RestoreCoursesCommand.Builder newRestoreCoursesCommandBuilder(final Course course) {
		return new RestoreCoursesCommand.Builder(course);
	}

	public static RestoreDomainsCommand.Builder
		newRestoreDomainsCommandBuilder(final String parentId, final List<Domain> domains) {

		return new RestoreDomainsCommand.Builder(parentId, domains);
	}

	public static RestoreDomainsCommand.Builder
		newRestoreDomainsCommandBuilder(final Integer parentId, final List<Domain> domains) {

		return new RestoreDomainsCommand.Builder(parentId, domains);
	}

	public static RestoreDomainsCommand.Builder
		newRestoreDomainsCommandBuilder(final String parentId, final Domain domain) {

		return new RestoreDomainsCommand.Builder(parentId, domain);
	}

	public static RestoreDomainsCommand.Builder
		newRestoreDomainsCommandBuilder(final Integer parentId, final Domain domain) {

		return new RestoreDomainsCommand.Builder(parentId, domain);
	}

	public static RestoreEnrollmentsCommand.Builder
		newRestoreEnrollmentsCommandBuilder(final List<Enrollment> enrollments) {

		return new RestoreEnrollmentsCommand.Builder(enrollments);
	}

	public static RestoreEnrollmentsCommand.Builder newRestoreEnrollmentsCommandBuilder(final Enrollment enrollment) {
		return new RestoreEnrollmentsCommand.Builder(enrollment);
	}

	public static RestoreSectionsCommand.Builder newRestoreSectionsCommandBuilder(final List<Section> sections) {
		return new RestoreSectionsCommand.Builder(sections);
	}

	public static RestoreSectionsCommand.Builder newRestoreSectionsCommandBuilder(final Section section) {
		return new RestoreSectionsCommand.Builder(section);
	}

	public static RestoreUsersCommand.Builder newRestoreUsersCommandBuilder(final List<User> users) {
		return new RestoreUsersCommand.Builder(users);
	}

	public static RestoreUsersCommand.Builder newRestoreUsersCommandBuilder(final User user) {
		return new RestoreUsersCommand.Builder(user);
	}

	public static SamlLoginCommand.Builder newSamlLoginCommandBuilder(final String userspace, final String response) {
		return new SamlLoginCommand.Builder(userspace, response);
	}

	public static SendEmailCommand.Builder newSendEmailCommandBuilder(final String enrollmentId, final Email email) {
		return new SendEmailCommand.Builder(enrollmentId, email);
	}

	public static SendEmailCommand.Builder newSendEmailCommandBuilder(final Integer enrollmentId, final Email email) {
		return new SendEmailCommand.Builder(enrollmentId, email);
	}

	public static SsoLoginCommand.Builder
		newSsoLoginCommandBuilder(final String system, final String domainId, final String ticket, final String service) {

		return new SsoLoginCommand.Builder(system, domainId, ticket, service);
	}

	public static SsoLoginCommand.Builder
		newSsoLoginCommandBuilder(final String system, final Integer domainId, final String ticket, final String service) {

		return new SsoLoginCommand.Builder(system, domainId, ticket, service);
	}

	public static UnlinkDomainsCommand.Builder
		newUnlinkDomainsCommandBuilder(final String parentId, final List<Domain> domains) {

		return new UnlinkDomainsCommand.Builder(parentId, domains);
	}

	public static UnlinkDomainsCommand.Builder
		newUnlinkDomainsCommandBuilder(final Integer parentId, final List<Domain> domains) {

		return new UnlinkDomainsCommand.Builder(parentId, domains);
	}

	public static UnlinkDomainsCommand.Builder
		newUnlinkDomainsCommandBuilder(final String parentId, final Domain domain) {

		return new UnlinkDomainsCommand.Builder(parentId, domain);
	}

	public static UnlinkDomainsCommand.Builder
		newUnlinkDomainsCommandBuilder(final Integer parentId, final Domain domain) {

		return new UnlinkDomainsCommand.Builder(parentId, domain);
	}

	public static UnproxyCommand.Builder newUnproxyCommandBuilder() {
		return new UnproxyCommand.Builder();
	}

	public static UpdateCoursesCommand.Builder newUpdateCoursesCommandBuilder(final List<Course> courses) {
		return new UpdateCoursesCommand.Builder(courses);
	}

	public static UpdateCoursesCommand.Builder newUpdateCoursesCommandBuilder(final Course course) {
		return new UpdateCoursesCommand.Builder(course);
	}

	public static UpdateDomainsCommand.Builder newUpdateDomainsCommandBuilder(final List<Domain> domains) {
		return new UpdateDomainsCommand.Builder(domains);
	}

	public static UpdateDomainsCommand.Builder newUpdateDomainsCommandBuilder(final Domain domain) {
		return new UpdateDomainsCommand.Builder(domain);
	}

	public static UpdateEnrollmentsCommand.Builder
		newUpdateEnrollmentsCommandBuilder(final List<Enrollment> enrollments) {

		return new UpdateEnrollmentsCommand.Builder(enrollments);
	}

	public static UpdateEnrollmentsCommand.Builder
		newUpdateEnrollmentsCommandBuilder(final Enrollment enrollment) {

		return new UpdateEnrollmentsCommand.Builder(enrollment);
	}

	public static UpdateGroupsCommand.Builder
		newUpdateGroupsCommandBuilder(final List<Group> groups) {

		return new UpdateGroupsCommand.Builder(groups);
	}

	public static UpdateGroupsCommand.Builder
		newUpdateGroupsCommandBuilder(final Group group) {

		return new UpdateGroupsCommand.Builder(group);
	}

	public static UpdatePasswordCommand.Builder
		newUpdatePasswordCommandBuilder(final String userId, final String password) {

		return new UpdatePasswordCommand.Builder(userId, password);
	}

	public static UpdatePasswordCommand.Builder
		newUpdatePasswordCommandBuilder(final Integer userId, final String password) {

		return new UpdatePasswordCommand.Builder(userId, password);
	}

	public static UpdatePasswordQuestionAnswerCommand.Builder
		newUpdatePasswordQuestionAnswerCommandBuilder(final String userId, final String passwordQuestion, final String passwordAnswer) {

		return new UpdatePasswordQuestionAnswerCommand.Builder(userId, passwordQuestion, passwordAnswer);
	}

	public static UpdatePasswordQuestionAnswerCommand.Builder
		newUpdatePasswordQuestionAnswerCommandBuilder(final Integer userId, final String passwordQuestion, final String passwordAnswer) {

		return new UpdatePasswordQuestionAnswerCommand.Builder(userId, passwordQuestion, passwordAnswer);
	}

	public static UpdateRightsCommand.Builder newUpdateRightsCommandBuilder(final List<Right> rights) {
		return new UpdateRightsCommand.Builder(rights);
	}

	public static UpdateRightsCommand.Builder newUpdateRightsCommandBuilder(final Right right) {
		return new UpdateRightsCommand.Builder(right);
	}

	public static UpdateSectionsCommand.Builder newUpdateSectionsCommandBuilder(final List<Section> sections) {
		return new UpdateSectionsCommand.Builder(sections);
	}

	public static UpdateSectionsCommand.Builder newUpdateSectionsCommandBuilder(final Section section) {
		return new UpdateSectionsCommand.Builder(section);
	}

	public static UpdateUsersCommand.Builder newUpdateUsersCommandBuilder(final List<User> users) {
		return new UpdateUsersCommand.Builder(users);
	}

	public static UpdateUsersCommand.Builder newUpdateUsersCommandBuilder(final User user) {
		return new UpdateUsersCommand.Builder(user);
	}
}