package org.hashtree.jbrainhoney.dlap.command;

/**
 * A command which returns the data posted. See the
 * {@link <a href="http://gls.agilix.com/Docs/Command/Echo">the BrainHoney DLAP API guide</a>} for this command.
 */
public final class EchoCommand implements Command {
	private final String echo;

	@SuppressWarnings("synthetic-access")
	private EchoCommand(final Builder builder) throws IllegalArgumentException {
		if(builder.echo == null) throw new IllegalArgumentException("Expected echo to not be null.");

		echo = builder.echo;
	}

	public String getEcho() {
		return echo;
	}

	/** A builder of immutable EchoCommand instances. */
	public final static class Builder implements Command.Builder {
		private final String echo;

		public Builder(final String echo) {
			super();

			this.echo = echo;
		}

		@Override
		@SuppressWarnings("synthetic-access")
		public EchoCommand build() {
			return new EchoCommand(this);
		}
	}
}