package org.hashtree.jbrainhoney.dlap.element;

/** A class which consists exclusively of static methods that operate on or return elements and their builders. */
public final class Elements {
	private Elements() {

	}

	public static Agent.Builder newAgentBuilder() {
		return new Agent.Builder();
	}

	public static Course.Builder newCourseBuilder() {
		return new Course.Builder();
	}

	public static Domain.Builder newDomainBuilder() {
		return new Domain.Builder();
	}

	public static Email.Builder newEmailBuilder(final String subject) {
		return new Email.Builder(subject);
	}

	public static Enrollment.Builder newEnrollmentBuilder() {
		return new Enrollment.Builder();
	}

	public static Group.Builder newGroupBuilder() {
		return new Group.Builder();
	}

	public static Right.Builder newRightBuilder() {
		return new Right.Builder();
	}

	public static Section.Builder newSectionBuilder() {
		return new Section.Builder();
	}

	public static User.Builder newUserBuilder() {
		return new User.Builder();
	}
}