package org.hashtree.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates email recipients. */
public enum EmailRecipient implements ValueEnumeration {
	ALL("All"),
	STUDENTS("Students"),
	TEACHERS("Teachers");

	private final String value;

	private EmailRecipient(final String value) {
		this.value = value;
	}

	@Override
	public String getValue() {
		return value;
	}

	public static EmailRecipient valueOfValue(final String value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		EmailRecipient enumeration = null;

		for(EmailRecipient element : EnumSet.allOf(EmailRecipient.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}