package org.hashtree.jbrainhoney.dlap.validate;

/** A validator class for a userspace attribute. */
public final class UserspaceAttributeValidator implements AttributeValidator<String> {
	private volatile static UserspaceAttributeValidator instance;

	private UserspaceAttributeValidator() {

	}

	@Override
	public boolean isValid(final String userspace) {
		if(userspace == null || userspace.length() == 0 || userspace.length() > 128 ||!userspace.matches("^([^/]+?)$"))
			return false;
		else return true;
	}

	public static UserspaceAttributeValidator getInstance() {
		if(instance == null) synchronized(UserspaceAttributeValidator.class) {
			if(instance == null) instance = new UserspaceAttributeValidator();
		}

		return instance;
	}

	@Override
	public final java.lang.Object clone() throws CloneNotSupportedException {
		 throw new CloneNotSupportedException();
	}
}